/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CampaignTargetChannelsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignTargetChannelsInner{}

// CampaignTargetChannelsInner struct for CampaignTargetChannelsInner
type CampaignTargetChannelsInner struct {
	ChannelId string `json:"channel_id"`
	InteractionId string `json:"interaction_id"`
	Main *bool `json:"main,omitempty"`
}

// NewCampaignTargetChannelsInner instantiates a new CampaignTargetChannelsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignTargetChannelsInner(channelId string, interactionId string) *CampaignTargetChannelsInner {
	this := CampaignTargetChannelsInner{}
	this.ChannelId = channelId
	this.InteractionId = interactionId
	return &this
}

// NewCampaignTargetChannelsInnerWithDefaults instantiates a new CampaignTargetChannelsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignTargetChannelsInnerWithDefaults() *CampaignTargetChannelsInner {
	this := CampaignTargetChannelsInner{}
	return &this
}

// GetChannelId returns the ChannelId field value
func (o *CampaignTargetChannelsInner) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *CampaignTargetChannelsInner) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *CampaignTargetChannelsInner) SetChannelId(v string) {
	o.ChannelId = v
}

// GetInteractionId returns the InteractionId field value
func (o *CampaignTargetChannelsInner) GetInteractionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value
// and a boolean to check if the value has been set.
func (o *CampaignTargetChannelsInner) GetInteractionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.InteractionId, true
}

// SetInteractionId sets field value
func (o *CampaignTargetChannelsInner) SetInteractionId(v string) {
	o.InteractionId = v
}

// GetMain returns the Main field value if set, zero value otherwise.
func (o *CampaignTargetChannelsInner) GetMain() bool {
	if o == nil || IsNil(o.Main) {
		var ret bool
		return ret
	}
	return *o.Main
}

// GetMainOk returns a tuple with the Main field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignTargetChannelsInner) GetMainOk() (*bool, bool) {
	if o == nil || IsNil(o.Main) {
		return nil, false
	}
	return o.Main, true
}

// HasMain returns a boolean if a field has been set.
func (o *CampaignTargetChannelsInner) HasMain() bool {
	if o != nil && !IsNil(o.Main) {
		return true
	}

	return false
}

// SetMain gets a reference to the given bool and assigns it to the Main field.
func (o *CampaignTargetChannelsInner) SetMain(v bool) {
	o.Main = &v
}

func (o CampaignTargetChannelsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignTargetChannelsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["interaction_id"] = o.InteractionId
	if !IsNil(o.Main) {
		toSerialize["main"] = o.Main
	}
	return toSerialize, nil
}

type NullableCampaignTargetChannelsInner struct {
	value *CampaignTargetChannelsInner
	isSet bool
}

func (v NullableCampaignTargetChannelsInner) Get() *CampaignTargetChannelsInner {
	return v.value
}

func (v *NullableCampaignTargetChannelsInner) Set(val *CampaignTargetChannelsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignTargetChannelsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignTargetChannelsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignTargetChannelsInner(val *CampaignTargetChannelsInner) *NullableCampaignTargetChannelsInner {
	return &NullableCampaignTargetChannelsInner{value: val, isSet: true}
}

func (v NullableCampaignTargetChannelsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignTargetChannelsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


